diff --git a/src/common/gui/CSwitchControl.cpp b/src/common/gui/CSwitchControl.cpp
index 885f88154..5486279d1 100644
--- a/src/common/gui/CSwitchControl.cpp
+++ b/src/common/gui/CSwitchControl.cpp
@@ -81,7 +81,6 @@ CMouseEventResult CSwitchControl::onMouseDown(CPoint& where, const CButtonState&
    if( unValueClickable )
       return kMouseDownEventHandledButDontNeedMovedOrUpEvents;
 
-   beginEdit();
 
    if (is_itype)
    {
@@ -92,6 +91,7 @@ CMouseEventResult CSwitchControl::onMouseDown(CPoint& where, const CButtonState&
       down = !down;
       value = down ? 1 : 0;
    }
+   beginEdit();
 
    value_direction = 1;
    if (listener)
